/*
 * Created by victoria on 2021-05-12.
 */

#pragma once

#include <QXmppPubSubIq.h>

namespace QOmemo {

class Device {
public:
  [[nodiscard]] QXmppElement toXml() const;
  void fromXml(const QXmppElement &element);

  int id;
  QString label;
};

class DeviceList {
public:
  [[nodiscard]] QXmppElement toXml() const;
  [[nodiscard]] QXmppIq toIq() const;
  /// Expects a urn:xmpp:omemo:1:devices node
  void fromXml(const QXmppElement &element);

private:
  QList<Device> devices;
};

class PreKey {
public:
  [[nodiscard]] QXmppElement toXml() const;
  /// Expects a <pk>
  void fromXml(const QXmppElement &element);

  int id;
  QString data;
};

class Bundle {
public:
  [[nodiscard]] QXmppElement toXml() const;
  [[nodiscard]] QXmppIq toIq() const;
  void fromXml(const QXmppElement &element);

  int deviceId;

  QString spk;
  int spkId;
  QString spks;
  QString ik;
  QList<PreKey> prekeys;
};

} // namespace QOmemo
